"use strict";
var http_1 = require('@angular/http');
var RestangularHelper = (function () {
    function RestangularHelper() {
    }
    RestangularHelper.createRequestOptions = function (options) {
        var requestQueryParams = RestangularHelper.createRequestQueryParams(options.params);
        var requestHeaders = RestangularHelper.createRequestHeaders(options.headers);
        var methodName = options.method.charAt(0).toUpperCase() + options.method.substr(1).toLowerCase();
        var requestOptions = new http_1.RequestOptions({
            method: http_1.RequestMethod[methodName],
            headers: requestHeaders,
            search: requestQueryParams,
            url: options.url,
            body: options.data,
        });
        return requestOptions;
    };
    RestangularHelper.createRequestQueryParams = function (queryParams) {
        var requestQueryParams = Object.assign({}, queryParams);
        var search = new http_1.URLSearchParams();
        for (var key in requestQueryParams) {
            var value = requestQueryParams[key];
            if (typeof value === 'object') {
                value = JSON.stringify(value);
            }
            search.append(key, value);
        }
        return search;
    };
    RestangularHelper.createRequestHeaders = function (headers) {
        for (var key in headers) {
            var value = headers[key];
            if (typeof value === 'undefined') {
                delete headers[key];
            }
        }
        return new http_1.Headers(Object.assign({}, headers));
    };
    return RestangularHelper;
}());
exports.RestangularHelper = RestangularHelper;
//# sourceMappingURL=ng2-restangular-helper.js.map